<?php
/*
Plugin Name: Proofread Bot
Plugin URI: http://proofreadbot.com
Description: Plagiarism and Duplicate Content Detection - Check your content for duplication and plagiarism straight from your Wordpress admin
Version: 1.7
Author: Macadu Ltd
Author URI: http://proofreadbot.com
*/

include('classes/proofread_bot_api.php');


/*
* Set up options, convert old options, add filters if automatic display is enabled, and enqueue scripts
* @uses get_option, update_option, add_filter, wp_enqueue_script
* @return null
*/

/* Define the custom box */
add_action( 'add_meta_boxes', 'proofread_bot_add_custom_box' );


/* Adds a box to the main column on the Post and Page edit screens */
function proofread_bot_add_custom_box() {
	add_meta_box( 
	'proofread_bot',
	__( 'Proofread Bot Report', 'proofread_bot_textdomain' ),
	'proofread_bot_inner_custom_box',
	'post' 
	);
}

/* Prints the box content */
function proofread_bot_inner_custom_box( $post ) {

	// Use nonce for verification
	wp_nonce_field( plugin_basename( __FILE__ ), 'proofread_bot_noncename' );

	// The actual fields for data entry
	//echo '<label for="proofread_bot_new_field">';
	//_e("Proofread Bot results will appear here", 'proofread_bot_textdomain' );
	//echo '</label> ';
	echo '<button type="button"  id="proofread_bot-submit" onclick="return false;">Get your Proofread Bot Report</button>
		<div id="proofread_bot_result"></div>';
	echo '<script>        jQuery(document).ready(function(){

		//console.log(tinyMCE.activeEditor.getContent(content));
	
		jQuery("#proofread_bot-submit").click(function(event){

		jQuery("#proofread_bot-submit").after("<div id=\"proofread_bot_throbber\"><img src=\"'. WP_PLUGIN_URL.'/proofread-bot/throbber.gif\" /> Fetching report, may take a few seconds...</div>");

		
			var data = {
			action: \'post_check_proofread_bot\',
			"text": jQuery("#content_ifr").contents().find("#tinymce").html()
		};

			// since 2.8 ajaxurl is always defined in the admin header and points to admin-ajax.php
			jQuery.post(ajaxurl, data, function(response) {
				jQuery("#proofread_bot-submit").after(response);
				jQuery("#proofread_bot_throbber").remove(); 
			});	    		  
		});
		});
		</script>';
}

// AJAX
add_action('wp_ajax_post_check_proofread_bot', 'proofread_bot_post_ajax_check');

function proofread_bot_post_ajax_check()
{   
	$post = $_POST['text'];

	if(current_user_can('check_proofread_bot'))
	{

		$proofread_bot_results = proofread_bot_check_api($post, $_POST);

		print_r($proofread_bot_results);
	//echo "IN HERE";
	}


	die();
}


function proofread_bot_setup() {
	//Add filters if set to automatic display
	add_filter( 'the_content', 'proofread_bot_auto' );
	//if( $options[ 'display' ] == 1 && $options[ 'content-excerpt' ] == 1 ) add_filter( 'the_excerpt', 'proofread_bot_auto' );
}
add_action( 'plugins_loaded', 'proofread_bot_setup' );


function proofread_bot_auto( $content ) {
	global $post;
	$options = get_option('proofread_bot_options');
	//print_r($options);
	
	$button_link="http://www.proofreadbot.com";
	if(strlen($options['proofread_bot_affiliate_id']) > 0) 
	{
		$button_link="http://".$options['proofread_bot_affiliate_id'].".proofbot.hop.clickbank.net/\" rel=\"nofollow";
	}
	
	$button = "<a href=\"".$button_link."\" target=\"_blank\"><img src=\"". WP_PLUGIN_URL ."/proofread-bot/buttons/small_".$options["proofread_bot_button"]."-button1-".$options["proofread_bot_button_color"].".png\" /></a>";
	
	//print $button;
	
	//Add button to $content
	if( $options[ 'proofread_bot_placement_posts' ] == true)  
	$content = $content . $button;

	
	return $content;
	
}

add_action('admin_menu', 'proofread_botoptions_add_page_fn');
// Add sub page to the Settings Menu
function proofread_botoptions_add_page_fn() {
	add_options_page('Proofread Bot', 'Proofread Bot', 'administrator', __FILE__, 'proofread_bot_options_page');
}

function proofread_bot_options_page() {
	?>
	<div class="wrap">
	<div class="icon32" id="icon-options-general"><br></div>
	<h2>Proofread Bot Options</h2>
	You can use Proofread Bot plugin without filling out the account details here, and you have 1 free proofread credit (600 words) per day. For more checks please <a href="http://proofreadbot.com/invite-your-friends" target="_blank">invite your friends <img src="<?php print WP_PLUGIN_URL ?>/proofread_bot/facebook.png" /></a> or <a href="http://proofreadbot.com/node/2">purchase a package</a>, 1 automated proofread credit = 1 friend invite or 0.01$ (1 cent).
	<form action="options.php" method="post">
	<?php settings_fields('proofread_bot_options'); ?>
	<?php do_settings_sections(__FILE__); ?>
	<p class="submit">
	<input name="Submit" type="submit" class="button-primary" value="<?php esc_attr_e('Save Changes'); ?>" />
	</p>
	</form>
	</div>
	<?php
}

add_action('admin_init', 'proofread_botsoptions_init_fn' );
// Register our settings. Add the settings section, and settings fields
function proofread_botsoptions_init_fn(){
	register_setting('proofread_bot_options', 'proofread_bot_options', 'proofread_bot_options_validate' );

	add_settings_section('main_section', 'Proofread Bot Account Details', 'proofread_bot_section_text_fn', __FILE__);

	add_settings_field('proofread_bot_username', 'Proofread Bot Username', 'proofread_bot_setting_username_fn', __FILE__, 'main_section');
	add_settings_field('proofread_bot_password', 'Proofread Bot Password', 'proofread_bot_setting_password_fn', __FILE__, 'main_section');
	add_settings_field('min_user_level', 'Lowest Role that can check Proofread Bot', 'proofread_bot_setting_role_fn', __FILE__, 'main_section');

	add_settings_section('button_section', 'Proofread Bot Button Settings', 'proofread_bot_button_section_text_fn', __FILE__);

	add_settings_field('proofread_bot_button', 'Select Button', 'proofread_bot_setting_button_fn', __FILE__, 'button_section');
	add_settings_field('proofread_bot_button_color', 'Select Button Color', 'proofread_bot_setting_button_color_fn', __FILE__, 'button_section');
	// add_settings_field('proofread_bot_button_placement_homepage', 'Show button on homepage', 'proofread_bot_setting_button_placement_homepage_fn', __FILE__, 'button_section');
	add_settings_field('proofread_bot_button_placement_posts', 'Show button on posts', 'proofread_bot_setting_button_placement_posts_fn', __FILE__, 'button_section');

	add_settings_section('affiliate_section', 'Proofread Bot Affiliate Program - Make Money', 'proofread_bot_affiliate_section_text_fn', __FILE__);
	add_settings_field('proofread_bot_affiliate_id', 'Proofread Bot Affiliate Id', 'proofread_bot_setting_affiliate_id_fn', __FILE__, 'affiliate_section');
	
	// add custom capability depending on settings
	$options = get_option('proofread_bot_options');
	$min_role = $options ? $options['role'] : 'administrator' ;
	$roles = array('Administrator'=>'administrator', 'Editor'=>'editor', 'Author'=>'author', 'Contributor'=>'contributor');

	foreach($roles as $role=>$val)
	{
		$role = get_role($val);
		$role->add_cap( 'check_proofread_bot' );

		if($val == $min_role)
		break;
	}
}

function proofread_bot_section_text_fn()
{
	echo '<p>Enter your Proofread Bot account details.</p>';
}

function proofread_bot_button_section_text_fn()
{
	echo '<p>Select optionally a button to show your visitors you care about grammar and style on your site! You can also make some money by participating in the Proofread Bot affiliate program.</p>';
}

function proofread_bot_affiliate_section_text_fn()
{
	echo '<p>Make money by participating in the Proofread Bot affiliate program, powered by Clickbank. The button you selected will link with your clickbank id so referrals can be credited to you. If you don\'t have a clickbank id  get it  <a rel="nofollow" href="http://proofreadbot.com/affiliate/signup" target="_blank">here</a>, you will be taken to the Clickbank vendor / affiliate signup page. (Vendor and affiliate accounts are the same at Clickbank.)</p>';
}

function proofread_bot_options_validate($input) {
	// Check our textbox option field contains no HTML tags - if so strip them out
	return $input; // return validated input
}

function proofread_bot_setting_role_fn() {
	$options = get_option('proofread_bot_options');
	$items = array('Administrator'=>'administrator', 'Editor'=>'editor', 'Author'=>'author', 'Contributor'=>'contributor');

	echo "<select id='proofread_bot_role' name='proofread_bot_options[role]'>";

	foreach($items as $item=>$value)
	{
		$selected = ($options['role']== $value ) ? 'selected="selected"' : '';
		echo "<option value='$value' $selected>$item</option>";
	}

	echo "</select>";
}

function proofread_bot_setting_username_fn() {
	$options = get_option('proofread_bot_options');
	echo "<input name='proofread_bot_options[proofread_bot_username]' size='40' type='text' value='{$options['proofread_bot_username']}' />";
}

function proofread_bot_setting_password_fn() {
	$options = get_option('proofread_bot_options');
	echo "<input name='proofread_bot_options[proofread_bot_password]' size='40' type='text' value='{$options['proofread_bot_password']}' />";
}

function proofread_bot_setting_affiliate_id_fn() {
	$options = get_option('proofread_bot_options');
	echo "<input name='proofread_bot_options[proofread_bot_affiliate_id]' size='40' type='text' value='{$options['proofread_bot_affiliate_id']}' />";
}


function proofread_bot_setting_button_fn() {
	$options = get_option('proofread_bot_options');
	//print_r($options);
	?>
	<fieldset>
	<label><input name='proofread_bot_options[proofread_bot_button]' value='proofreadbot' type='radio' <?php if( !$options['proofread_bot_button'] || $options['proofread_bot_button']=='proofreadbot' ) echo ' checked="checked"'; ?>>
	<img src="<?php echo WP_PLUGIN_URL ?>/proofread-bot/buttons/small_proofreadbot-button1-light.png" /></label><br/>
	<label><input name='proofread_bot_options[proofread_bot_button]' value='perfect_grammar' type='radio' <?php if( !$options['proofread_bot_button'] || $options['proofread_bot_button']=='perfect_grammar' ) echo ' checked="checked"'; ?>>
	<img src="<?php echo WP_PLUGIN_URL ?>/proofread-bot/buttons/small_perfect_grammar-button1-light.png" /></label>
	</fieldset> 	
	<?php
}

function proofread_bot_setting_button_color_fn() {
	$options = get_option('proofread_bot_options');
	$items = array('Light'=>'light', 'Dark'=>'dark', 'Green'=>'green', 'Red'=>'red', 'Yellow'=>'yellow', 'Blue'=>'blue');

	echo "<select id='proofread_bot_button_color' name='proofread_bot_options[proofread_bot_button_color]'>";

	foreach($items as $item=>$value)
	{
		$selected = ($options['proofread_bot_button_color']== $value ) ? 'selected="selected"' : '';
		echo "<option value='$value' $selected>$item</option>";
	}

	echo "</select>";
}

function proofread_bot_setting_button_placement_homepage_fn() {
	$options = get_option('proofread_bot_options');
	if( $options['proofread_bot_placement_homepage']== true) 
	$checked = 'checked="checked"';

	echo "<input name='proofread_bot_options[proofread_bot_placement_homepage]' type='checkbox' value='true' $checked />";
}

function proofread_bot_setting_button_placement_posts_fn() {
	$options = get_option('proofread_bot_options');

	if($options['proofread_bot_placement_posts']== true )
	$checked = 'checked="checked"';
	
	echo "<input name='proofread_bot_options[proofread_bot_placement_posts]' type='checkbox' value='true' $checked />";
}


// Place in Option List on Settings > Plugins page 
function proofread_bot_actlinks( $links, $file ){
	//Static so we don't call plugin_basename on every plugin row.
	static $this_plugin;
	if ( ! $this_plugin ) $this_plugin = plugin_basename(__FILE__);
	
	if ( $file == $this_plugin ){
		$settings_link = '<a href="options-general.php?page=proofread-bot/proofread_bot.php">' . __('Settings') . '</a>';
		array_unshift( $links, $settings_link ); // before other links
		}
	return $links;
}
add_filter("plugin_action_links", 'proofread_bot_actlinks', 10, 2);

?>